package demo.barcharts.xy ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.StackedXYBarValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StackedXYBarChartDemo1 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public StackedXYBarChartDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    final IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createStackedXYBarChart(
      "Stacked XY Bar Chart Demo 1", "X", "Y", dataset, orientation, true, true, false, false) ;

    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    StackedXYBarValueAxis domainAxis = (StackedXYBarValueAxis) xyplot.getDomainAxis() ;
    domainAxis.setTickUnit(new LongTickUnit()) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;

    double[][] data1 = { {1.0D, 5D}, {2D, 15.5D}, {3D, 9.5D}, {4D, 7.5D}
    } ;
    double[][] data2 = { {1.0D, 5D}, {2D, 15.5D}, {3D, 9.5D}, {4D, 3.5D}
    } ;
    dataset.addRowData(2) ;

    for (int i = 0 ; i < 4 ; i++) {
      dataset.addData(0, new XYNumberChartData(data1[i][0], data1[i][1])) ;
      dataset.addData(1, new XYNumberChartData(data2[i][0], data2[i][1])) ;
    }

    return dataset ;
  }

}
