package demo.financialcharts;

import java.awt.GridLayout ;
import java.util.Calendar ;
import java.util.Date ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.OHLCValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.format.NumberFormatter ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.util.DatasetUtil ;
import demo.others.HighLowChartPanel1 ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class HighLowChartDemo2 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  /** A working calendar. */
  private static final Calendar CALENDAR = Calendar.getInstance() ;

  private SingleRowDataset dataset = HighLowChartPanel1.createDataset1() ;

  public HighLowChartDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IJChart chart = ChartFactory.createHighLowChart(
      "HighLowChartDemo2", "Time", "Value", dataset, vertical, true, true) ;

    IMatrixDataset averageDataset =
      DatasetUtil.createMovingAverageOHLCDataset(dataset, null, null, 3) ;
    XYLineAndShapeRender render = new XYLineAndShapeRender(averageDataset) ;
    render.setBaseItemShapeVisible(false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.setRender(1, render) ;
    OHLCValueAxis numberaxis = (OHLCValueAxis) plot.getValueAxis() ;
    numberaxis.setTickValueFormatter(new NumberFormatter("$0.00")) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  /**
   * Creates a date.
   *
   * @param year  the year.
   * @param month  the month (1 - 12).
   * @param day  the day.
   * @param hour  the hour.
   * @param min  the minute.
   *
   * @return a date.
   */
  public static synchronized Date createDate(final int year, final int month, final int day,
                                             final int hour, final int min) {
    CALENDAR.clear() ;
    CALENDAR.set(year, month - 1, day, hour, min) ;

    return CALENDAR.getTime() ;
  }

}
