package demo.granttcharts ;

import java.awt.GridLayout ;
import java.util.Calendar ;
import java.util.Date ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.GranttChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class GanttDemo1 extends JPanel {

  private ChartOrientation orientation = ChartOrientation.HORIZONTAL ;

  public GanttDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createGranttChart(
      "Gantt Chart Demo 1", "Task", "Date", dataset, orientation, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.getCategoryAxis().setMaximumCategoryLabelWidthRatio(10F) ;
    plot.setValueCrosshairVisible(true) ;
    plot.setDomainGridlineVisible(false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Scheduled") ;
    dataset.addColKey("Actual") ;

    dataset.addRowKey("Write Proposal") ;
    dataset.addRowKey("Obtain Approval") ;
    dataset.addRowKey("Requirements Analysis") ;
    dataset.addRowKey("Design Phase") ;
    dataset.addRowKey("Design Signoff") ;
    dataset.addRowKey("Alpha Implementation") ;
    dataset.addRowKey("Design Review") ;
    dataset.addRowKey("Revised Design Signoff") ;
    dataset.addRowKey("Beta Implementation") ;
    dataset.addRowKey("Testing") ;
    dataset.addRowKey("Final Implementation") ;
    dataset.addRowKey("Signoff") ;

    Date[][] dateArr1 = { {createDate(1, 3, 2001), createDate(5, 3, 2001)}, {createDate(9, 3, 2001),
                        createDate(9, 3, 2001)}, {createDate(10, 3, 2001), createDate(5, 4, 2001)},
                        {createDate(6, 4, 2001), createDate(30, 4, 2001)}, {createDate(2, 5, 2001),
                        createDate(2, 5, 2001)}, {createDate(3, 5, 2001), createDate(31, 6, 2001)},
                        {createDate(1, 7, 2001), createDate(8, 7, 2001)}, {createDate(10, 7, 2001),
                        createDate(10, 7, 2001)}, {createDate(12, 7, 2001), createDate(12, 8, 2001)},
                        {createDate(13, 8, 2001), createDate(31, 9, 2001)}, {createDate(1, 10, 2001),
                        createDate(15, 10, 2001)}, {createDate(28, 10, 2001),
                        createDate(30, 10, 2001)}
    } ;

    Date[][] dateArr2 = { {createDate(1, 3, 2001), createDate(5, 3, 2001)}, {createDate(9, 3, 2001),
                        createDate(9, 3, 2001)}, {createDate(10, 3, 2001), createDate(15, 4, 2001)},
                        {createDate(15, 4, 2001), createDate(17, 5, 2001)}, {createDate(30, 5, 2001),
                        createDate(30, 5, 2001)}, {createDate(1, 6, 2001), createDate(12, 8, 2001)},
                        {createDate(12, 8, 2001), createDate(22, 8, 2001)}, {createDate(25, 8, 2001),
                        createDate(27, 8, 2001)}, {createDate(27, 8, 2001), createDate(30, 9, 2001)},
                        {createDate(31, 9, 2001), createDate(17, 10, 2001)},
                        {createDate(18, 10, 2001), createDate(5, 11, 2001)},
                        {createDate(10, 11, 2001), createDate(11, 11, 2001)}
    } ;

    dataset.addRowData(dateArr1.length) ;
    for (int i = 0 ; i < dateArr1.length ; i++) {
      dataset.addData(i, new GranttChartData(dateArr1[i][0], dateArr1[i][1], new Double(0))) ;
      dataset.addData(i, new GranttChartData(dateArr2[i][0], dateArr2[i][1], new Double(0))) ;
    }

    return dataset ;
  }

  private static Date createDate(int day, int month, int year) {
    Calendar calendar = Calendar.getInstance() ;
    calendar.set(year, month - 1, day) ;
    Date date1 = calendar.getTime() ;

    return date1 ;
  }

}
