package demo.images ;

import java.awt.BasicStroke ;
import java.awt.Color ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import demo.dataset.SampleXYDataset2 ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ScatterChartHotspotTest {

  public IJChart createChart() {
    SampleXYDataset2 sample = new SampleXYDataset2(4, 40) ;
    IMatrixDataset dataset = sample.getDataset() ;
    IJChart chart = ChartFactory.createScatterChart("Scatter Plot Demo 1", "X", "Y", dataset,
                                                    ChartOrientation.VERTICAL, true, true,
                                                    false, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;

    plot.setNoDataMessage("NO DATA") ;
    plot.setDomainZeroBaselineVisible(true) ;
    plot.setValueZeroBaselineVisible(true) ;
    plot.setDomainZeroBaselineStroke(new BasicStroke(0.0F)) ;
    plot.setDomainGridlinePaint(Color.blue) ;
    plot.setValueGridlineStroke(new BasicStroke(0.0F)) ;
    plot.setValueGridlinePaint(Color.blue) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    render.setBaseItemShapeVisible(true) ;
    render.setBaseItemLineVisible(false) ;
    render.setAutoSelectBorderPaint(false) ;
    render.setRowItemBorderPaint(0, Color.black) ;

    XYNumberValueAxis xAxis = (XYNumberValueAxis) plot.getDomainAxis() ;
    xAxis.setAxisRangeIncludeZero(false) ;
    xAxis.setTickMarkInsideLength(2.0F) ;
    xAxis.setTickMarkOutsideLength(2.0F) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) plot.getValueAxis() ;
    yAxis.setTickMarkInsideLength(2.0F) ;
    yAxis.setTickMarkOutsideLength(2.0F) ;

    return chart ;
  }

}
