package demo.images ;

import com.ijchart.xychart.axis.value.WaterfallNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.WaterfallBarRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class WaterfallChartHotspotTest {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  public IJChart createChart() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createWaterfallBarChart(
      "Product Cost Breakdown", "Expense Category", "Cost Per Unit", dataset, vertical, true, true) ;

    CategoryPlot categoryplot = (CategoryPlot) chart.getPlot() ;
    WaterfallNumberValueAxis valueaxis = (WaterfallNumberValueAxis) categoryplot.getValueAxis() ;
    valueaxis.setTickUnit(new LongTickUnit()) ;

    WaterfallBarRender render = (WaterfallBarRender) categoryplot.getRender() ;
    render.setBaseValue(5D) ;
    render.setBaseItemLabelVisible(true) ;

    return chart ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    dataset.addRowKey("Product 1") ;
    dataset.addColKey("Labour") ;
    dataset.addColKey("Administration") ;
    dataset.addColKey("Marketing") ;
    dataset.addColKey("Distribution") ;
    dataset.addColKey("Total Expense") ;

    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(15.76D)) ;
    dataset.addData(0, new NumberChartData(8.6600000000000001D)) ;
    dataset.addData(0, new NumberChartData(4.71D)) ;
    dataset.addData(0, new NumberChartData(3.5099999999999998D)) ;
    dataset.addData(0, new NumberChartData(32.640000000000001D)) ;

    return dataset ;
  }

}
