package demo.miscellaneous ;

import java.awt.BorderLayout ;
import java.awt.event.ActionEvent ;
import java.awt.event.ActionListener ;

import javax.swing.JCheckBox ;
import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYZNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.AbstractXYRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class HideSeriesDemo3 extends JPanel implements ActionListener {
  private IJChart chart ;

  public HideSeriesDemo3() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;

    JPanel jpanel = new JPanel() ;
    JCheckBox jcheckbox = new JCheckBox("Series 1") ;
    jcheckbox.setActionCommand("S1") ;
    jcheckbox.addActionListener(this) ;
    jcheckbox.setSelected(true) ;
    JCheckBox jcheckbox1 = new JCheckBox("Series 2") ;
    jcheckbox1.setActionCommand("S2") ;
    jcheckbox1.addActionListener(this) ;
    jcheckbox1.setSelected(true) ;
    JCheckBox jcheckbox2 = new JCheckBox("Series 3") ;
    jcheckbox2.setActionCommand("S3") ;
    jcheckbox2.addActionListener(this) ;
    jcheckbox2.setSelected(true) ;
    jpanel.add(jcheckbox) ;
    jpanel.add(jcheckbox1) ;
    jpanel.add(jcheckbox2) ;
    add(jpanel, BorderLayout.SOUTH) ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    chart = ChartFactory.createXYBubbleChart("Hide Series Demo 3", "X", "Y", dataset,
                                             ChartOrientation.VERTICAL, true, true, false, false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel, BorderLayout.CENTER) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;
    dataset.addRowKey("Series 3") ;
    dataset.addRowData(3) ;

    double ad[] = {2.1000000000000001D, 2.2999999999999998D, 2.2999999999999998D} ;
    double ad1[] = {14.1D, 11.1D, 10D} ;
    double ad2[] = {2.3999999999999999D, 2.7000000000000002D, 2.7000000000000002D} ;
    for (int i = 0 ; i < ad.length ; i++) {
      dataset.addData(0, new XYZNumberChartData(ad[i], ad1[i], ad2[i])) ;
    }

    ad = (new double[] {2.2000000000000002D, 2.2000000000000002D, 1.8D}) ;
    ad1 = (new double[] {14.1D, 11.1D, 10D}) ;
    ad2 = (new double[] {2.2000000000000002D, 2.2000000000000002D, 2.2000000000000002D}) ;
    for (int i = 0 ; i < ad.length ; i++) {
      dataset.addData(1, new XYZNumberChartData(ad[i], ad1[i], ad2[i])) ;
    }

    ad = (new double[] {1.8D, 1.8999999999999999D, 2.2999999999999998D, 3.7999999999999998D}) ;
    ad1 = (new double[] {5.4000000000000004D, 4.0999999999999996D, 4.0999999999999996D, 25D}) ;
    ad2 = (new double[] {2.1000000000000001D, 2.2000000000000002D, 1.6000000000000001D, 4D}) ;
    for (int i = 0 ; i < ad.length ; i++) {
      dataset.addData(2, new XYZNumberChartData(ad[i], ad1[i], ad2[i])) ;
    }

    return dataset ;
  }

  public void actionPerformed(ActionEvent actionevent) {
    int row = -1 ;
    if (actionevent.getActionCommand().equals("S1")) {
      row = 0 ;
    } else if (actionevent.getActionCommand().equals("S2")) {
      row = 1 ;
    } else if (actionevent.getActionCommand().equals("S3")) {
      row = 2 ;
    }

    if (row >= 0) {
      XYPlot plot = (XYPlot) chart.getPlot() ;
      AbstractXYRender render = plot.getRender() ;
      Boolean flag = render.isRowItemVisible(row) ;
      render.setRowItemVisible(row, flag == null ? false : !flag.booleanValue()) ;
    }

  }
}
