package demo.others ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.NumberChartDataFormatter ;
import com.ijchart.xychart.label.DefaultLabelGenerator ;
import com.ijchart.xychart.plot.Category3DPlot ;
import com.ijchart.xychart.render.category.Line3DRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class Line3DChartPanel1 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public Line3DChartPanel1() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel4() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createLine3DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    Category3DPlot plot = (Category3DPlot) chart.getPlot() ;
    Line3DRender render = (Line3DRender) plot.getRender() ;
    render.setLabelGenerator(new DefaultLabelGenerator(new NumberChartDataFormatter("#0.0"))) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createLine3DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    Category3DPlot plot = (Category3DPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;

    Line3DRender render = (Line3DRender) plot.getRender() ;
    render.setLabelGenerator(new DefaultLabelGenerator(new NumberChartDataFormatter("#0.0"))) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;

  }

  private void addPanel3() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createLine3DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    Category3DPlot plot = (Category3DPlot) chart.getPlot() ;
    Line3DRender render = (Line3DRender) plot.getRender() ;
    render.setLabelGenerator(new DefaultLabelGenerator(new NumberChartDataFormatter("#0.0"))) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;

  }

  private void addPanel4() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createLine3DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    Category3DPlot plot = (Category3DPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;

    Line3DRender render = (Line3DRender) plot.getRender() ;
    render.setLabelGenerator(new DefaultLabelGenerator(new NumberChartDataFormatter("#0.0"))) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;

  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("S1") ;
    dataset.addRowKey("S2") ;

    dataset.addColKey("C1") ;
    dataset.addColKey("C2") ;
    dataset.addColKey("C3") ;
    dataset.addColKey("C4") ;

    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(143.19999999999999D)) ;
    dataset.addData(0, new NumberChartData(120.2D)) ;
    dataset.addData(0, new NumberChartData(135D)) ;
    dataset.addData(0, new NumberChartData(115D)) ;

    dataset.addRowData() ;
    dataset.addData(1, new NumberChartData(98.700000000000003D)) ;
    dataset.addData(1, new NumberChartData(63.200000000000003D)) ;
    dataset.addData(1, new NumberChartData(71.400000000000006D)) ;
    dataset.addData(1, new NumberChartData(55D)) ;

    return dataset ;
  }

}
