package demo.others.categorycharts;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.LineAndShapeRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class CategoryLineAndShapeChartPanel2 extends JPanel {

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  private IMatrixDataset dataset = createDataset1() ;

  public CategoryLineAndShapeChartPanel2() {
    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {
    IJChart chart = ChartFactory.createCategoryLineAndShapeChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {
    IJChart chart = ChartFactory.createCategoryLineAndShapeChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {
    IJChart chart = ChartFactory.createCategoryLineAndShapeChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    LineAndShapeRender render = (LineAndShapeRender) plot.getRender() ;
    render.setRowItemLineVisible(1, false) ;
    render.setRowItemShapeFilled(2, false) ;
    render.setRowItemShapeVisible(3, false) ;

    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {
    IJChart chart = ChartFactory.createCategoryLineAndShapeChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    LineAndShapeRender render = (LineAndShapeRender) plot.getRender() ;
    render.setRowItemLineVisible(1, false) ;
    render.setRowItemShapeFilled(2, false) ;
    render.setRowItemShapeVisible(3, false) ;

    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("123456789011") ;
    dataset.addRowKey("abcdef") ;
    dataset.addRowKey("abcde") ;
    dataset.addRowKey("12345678") ;
    dataset.addRowKey("") ;

    for (int i = 0 ; i < 5 ; i++) {
      dataset.addRowData() ;
      for (int j = 0 ; j <= 10 ; j++) {
        if (i == 0 && j % 5 != 0) {
          dataset.addColKey("col key " + j) ;
        } else {
          dataset.addColKey("long col key " + j) ;
        }

        if (i % 2 == 0) {
          double value = -55 * Math.random() * ((i % 3) + 1) ;
          dataset.addData(i, new NumberChartData(value)) ;
        } else {
          double value = 55 * Math.random() * ((i % 3) + 1) ;
          dataset.addData(i, new NumberChartData(value)) ;
        }

      }
    }

    return dataset ;
  }

}
