package demo.others.categorycharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.StatisticalChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StatisticalBarChartPanel4 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  public StatisticalBarChartPanel4() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStaticalBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Row1") ;
    dataset.addRowKey("Row2") ;
    dataset.addRowKey("Row3") ;
    dataset.addRowKey("Row4") ;

    dataset.addColKey("col key 1") ;
    dataset.addColKey("col key 2") ;

    dataset.addRowData() ;
    dataset.addData(0, new StatisticalChartData(10D, 3D)) ;
    dataset.addData(0, new StatisticalChartData(22D, 2.3999999999999999D)) ;

    dataset.addRowData() ;
    dataset.addData(1, new StatisticalChartData( -10D, 5D)) ;
    dataset.addData(1, new StatisticalChartData(18D, 4.4000000000000004D)) ;

    dataset.addRowData() ;
    dataset.addData(2, new StatisticalChartData(13D, 2.1000000000000001D)) ;
    dataset.addData(2, new StatisticalChartData(28D, 2.1000000000000001D)) ;

    dataset.addRowData() ;
    dataset.addData(3, new StatisticalChartData(0D, 1.3D)) ;
    dataset.addData(3, new StatisticalChartData(17D, 1.3D)) ;

    return dataset ;
  }

}
