package demo.others.metercharts ;

import java.awt.BorderLayout ;
import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.BorderFactory ;
import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.MeterShapeType ;
import com.ijchart.xychart.data.StartEndNumberChartData ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.MeterRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class MeterChartPanel5 extends JPanel {

  private SingleRowDataset dataset ;

  public MeterChartPanel5() {
    dataset = createDataset() ;
    createDemoPanel() ;
  }

  public void createDemoPanel() {
    setLayout(new GridLayout(1, 3)) ;

    ChartPanel chartpanel1 = new ChartPanel(createChart("MeterShapeType.PIE", MeterShapeType.PIE)) ;
    chartpanel1.setBorder(BorderFactory.createLineBorder(Color.red)) ;

    ChartPanel chartpanel2 = new ChartPanel(createChart("MeterShapeType.CHORD",
                                                        MeterShapeType.CHORD)) ;
    chartpanel2.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    ChartPanel chartpanel3 = new ChartPanel(createChart("MeterShapeType.CIRCLE",
                                                        MeterShapeType.CIRCLE)) ;
    chartpanel3.setBorder(BorderFactory.createLineBorder(Color.red)) ;

//    JPanel chartpanel1 = new JPanel() ;
//    chartpanel1.setBorder(BorderFactory.createLineBorder(Color.red)) ;
//    JPanel chartpanel2 = new JPanel() ;
//    chartpanel2.setBorder(BorderFactory.createLineBorder(Color.red)) ;
//    JPanel chartpanel3 = new JPanel() ;
//    chartpanel3.setBorder(BorderFactory.createLineBorder(Color.red)) ;

    add(BorderLayout.WEST, chartpanel1) ;
    add(BorderLayout.CENTER, chartpanel2) ;
    add(BorderLayout.EAST, chartpanel3) ;

  }

  private IJChart createChart(String s, MeterShapeType dialshape) {
    IJChart chart = ChartFactory.createMeterChart(s, dataset, true, true) ;
    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
    MeterRender render = (MeterRender) plot.getRender() ;
    render.setMeterShapeType(dialshape) ;
    render.setBackgroundPaint(Color.yellow) ;

    return chart ;
  }

  private static SingleRowDataset createDataset() {
    SingleRowDataset volumeDataset = new SingleRowDataset() ;
    volumeDataset.addRowKey("Volume") ;
    volumeDataset.addRowData() ;

    volumeDataset.addColKey("Normal") ;
    volumeDataset.addColKey("Warning") ;
    volumeDataset.addColKey("Critical") ;

    volumeDataset.addData(0, new StartEndNumberChartData(0.0D, 35D)) ;
    volumeDataset.addData(0, new StartEndNumberChartData(35D, 50D)) ;
    volumeDataset.addData(0, new StartEndNumberChartData(50D, 60D)) ;

    return volumeDataset ;
  }

}
