package demo.others.shapes ;

import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Rectangle2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.BorderFactory ;
import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.chartinfo.AxisShapeCollection ;
import com.ijchart.xychart.data.IChartData ;
import com.ijchart.xychart.data.XYZNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.render.paint.GrayPaintScale ;
import com.ijchart.xychart.render.paint.IPaintScale ;
import com.ijchart.xychart.shape.PaintScaleLegendChartShape ;
import com.ijchart.xychart.ui.RectangleEdge ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class PaintScaleLegendShapePanel extends JPanel {
  private Map hashMap = new HashMap() ;

  private JLabel label ;

  public PaintScaleLegendShapePanel() {
    init() ;
  }

  private void init() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(3, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;

    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel1() {
    final Rectangle2D rect = new Rectangle2D.Double(0, 35, 250, 100) ;
    IPaintScale scale = new GrayPaintScale(0, 1) ;

    final PaintScaleLegendChartShape shape =
      new PaintScaleLegendChartShape(scale, "value axis", RectangleEdge.TOP, rect, createDataset()) ;
//    shape.setAxisOffset(5) ;
    shape.setStripBorderPaint(Color.yellow) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        super.paintComponent(g) ;
        setBackground(Color.lightGray) ;

        g2.setPaint(Color.red) ;
        g2.draw(rect) ;
        shape.draw(g2) ;

        AxisShapeCollection axisShapes = shape.getAxisShapes() ;
        axisShapes.draw(g2) ;
      }
    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(160, 160)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel2() {
    final Rectangle2D rect = new Rectangle2D.Double(0, 35, 250, 100) ;
    IPaintScale scale = new GrayPaintScale(0, 1) ;

    final PaintScaleLegendChartShape shape =
      new PaintScaleLegendChartShape(scale, "value axis", RectangleEdge.BOTTOM, rect, createDataset()) ;
//    shape.setAxisOffset(5) ;
    shape.setStripBorderPaint(Color.yellow) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        super.paintComponent(g) ;
        setBackground(Color.lightGray) ;

        g2.setPaint(Color.red) ;
        g2.draw(rect) ;
        shape.draw(g2) ;

        AxisShapeCollection axisShapes = shape.getAxisShapes() ;
        axisShapes.draw(g2) ;
      }
    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(160, 160)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel3() {
    final Rectangle2D rect = new Rectangle2D.Double(0, 35, 250, 100) ;
    IPaintScale scale = new GrayPaintScale(0, 1) ;

    final PaintScaleLegendChartShape shape =
      new PaintScaleLegendChartShape(scale, "value axis", RectangleEdge.LEFT, rect, createDataset()) ;
//    shape.setAxisOffset(5) ;
    shape.setStripBorderPaint(Color.yellow) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        super.paintComponent(g) ;
        setBackground(Color.lightGray) ;

        g2.setPaint(Color.red) ;
        g2.draw(rect) ;
        shape.draw(g2) ;

        AxisShapeCollection axisShapes = shape.getAxisShapes() ;
        axisShapes.draw(g2) ;
      }
    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(160, 160)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel4() {
    final Rectangle2D rect = new Rectangle2D.Double(0, 35, 250, 100) ;
    IPaintScale scale = new GrayPaintScale(0, 1) ;

    final PaintScaleLegendChartShape shape =
      new PaintScaleLegendChartShape(scale, "value axis", RectangleEdge.RIGHT, rect, createDataset()) ;
//    shape.setAxisOffset(5) ;
    shape.setStripBorderPaint(Color.yellow) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        super.paintComponent(g) ;
        setBackground(Color.lightGray) ;

        g2.setPaint(Color.red) ;
        g2.draw(rect) ;
        shape.draw(g2) ;

        AxisShapeCollection axisShapes = shape.getAxisShapes() ;
        axisShapes.draw(g2) ;
      }
    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(160, 160)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private static IMatrixDataset createDataset() {
    return new DefaultMatrixDataset() {

      public int getRowCount() {
        return 1 ;
      }

      public int getColumnCount() {
        return 10000 ;
      }

      public IChartData getData(int i, int j) {
        double x = j / 100 - 50 ;
        double y = j - (j / 100) * 100 - 50 ;
        double z = Math.sin(Math.sqrt(x * x + y * y) / 5D) ;

        return new XYZNumberChartData(x, y, z) ;
      }

      public Object getRowKey(int i) {
        return "sin(sqrt(x + y))" ;
      }

    } ;

  }

}
