package demo.others.stackareacharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StackedXYAreaChartPanel4 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public StackedXYAreaChartPanel4() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;
//   addPanel2() ;
//   addPanel3() ;
//   addPanel4() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedXYAreaChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, false, false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedXYAreaChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, false, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {

    IJChart chart = ChartFactory.createStackedXYAreaChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", createDataset1(), horizontal, true, true, false, false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IJChart chart = ChartFactory.createStackedXYAreaChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", createDataset1(), horizontal, true, true, false, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Col1") ;
    dataset.addColKey("Col2") ;
    dataset.addColKey("Col3") ;
    dataset.addColKey("Col4") ;

    dataset.addRowKey("Row1") ;
    dataset.addRowKey("Row2") ;

    dataset.addRowData() ;
    dataset.addData(0, new XYNumberChartData(5D, 5D)) ;
    dataset.addData(0, new XYNumberChartData(10D, 15.5D)) ;
    dataset.addData(0, new XYNumberChartData(15D, 9.5D)) ;
    dataset.addData(0, new XYNumberChartData(20D, 7.5D)) ;

    dataset.addRowData() ;
    dataset.addData(1, new XYNumberChartData( -5D, 5D)) ;
//    dataset.addData(1, new XYNumberChartData( -10D, 15.5D)) ;
    dataset.addData(1, new XYNumberChartData( -15D, 9.5D)) ;
    dataset.addData(1, new XYNumberChartData( -20D, 7.5D)) ;

    return dataset ;
  }

}
