package demo.statisticalcharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.function.IFunction ;
import com.ijchart.xychart.function.NormalDistributionFunction ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;
import com.ijchart.xychart.util.DatasetUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class NormalDistributionDemo1 extends JPanel {

  public NormalDistributionDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IFunction function = new NormalDistributionFunction(0.0D, 1.0D) ;
    XYNumberChartData[] datas = DatasetUtil.getDatasByFunction(function, -5D, 5D, 100) ;

    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowData(1) ;
    dataset.addRowKey("Normal") ;
    dataset.addDatas(0, datas) ;

    IJChart chart = ChartFactory.createXYLineAndShapeChart("Normal Distribution 1", "X", "Y",
                                                           dataset, ChartOrientation.VERTICAL, true,
                                                           true, false, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    render.setBaseItemShapeVisible(false) ;

    XYNumberValueAxis xAxis = (XYNumberValueAxis) plot.getDomainAxis() ;
    xAxis.setTickUnit(new LongTickUnit()) ;
    plot.getValueAxis().setUpperMargin(0.03) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

}
