package demo.timeseriescharts ;

import java.awt.Color ;
import java.awt.GridLayout ;
import java.util.Calendar ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.DateTickUnitType ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.MillisecondsToDateFormatter ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.tickunit.DateTickUnit ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class TimeSeriesDemo11 extends JPanel {

  public TimeSeriesDemo11() {
    setLayout(new GridLayout(2, 2)) ;
    add(createPanel1("Chart 1 : 1 Year", "Series 1", 100, 365)) ;
    add(createPanel2("Chart 2 : 6 Months", "Series 2", 100, 365)) ;
    add(createPanel3("Chart 2 : 3 Months", "Series 3", 100, 365)) ;
    add(createPanel4("Chart 2 : 1 Months", "Series 4", 100, 365)) ;
  }

  private static ChartPanel createPanel1(String title, String rowKey, int inivVal, int cnt) {
    IMatrixDataset dataset = createDataset(rowKey, inivVal, cnt) ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart(title, "Date", "Price", dataset,
                                                           ChartOrientation.VERTICAL,
                                                           true, true, true, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;

    XYNumberValueAxis xAxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    xAxis.setTickUnit(new DateTickUnit(DateTickUnitType.DATE_UNIT_MONTH)) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) xyplot.getRender() ;
    render.setBaseItemShapeVisible(false) ;
    render.setAutoSelectBorderPaint(false) ;
    render.setBaseItemBorderPaint(Color.blue) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    return chartpanel ;
  }

  private static ChartPanel createPanel2(String title, String rowKey, int inivVal, int cnt) {
    IMatrixDataset dataset = createDataset(rowKey, inivVal, cnt) ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart(title, "Date", "Price", dataset,
                                                           ChartOrientation.VERTICAL,
                                                           true, true, true, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    XYNumberValueAxis xAxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    xAxis.setTickUnit(new DateTickUnit(DateTickUnitType.DATE_UNIT_MONTH)) ;
    xAxis.setTickValueFormatter(new MillisecondsToDateFormatter("yyyy-MM-dd")) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) xyplot.getRender() ;
    render.setBaseItemShapeVisible(false) ;
    render.setAutoSelectBorderPaint(false) ;
    render.setBaseItemBorderPaint(Color.blue) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    return chartpanel ;
  }

  private static ChartPanel createPanel3(String title, String rowKey, int inivVal, int cnt) {
    IMatrixDataset dataset = createDataset(rowKey, inivVal, cnt) ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart(title, "Date", "Price", dataset,
                                                           ChartOrientation.VERTICAL,
                                                           true, true, true, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;

    XYNumberValueAxis xAxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    xAxis.setTickUnit(new DateTickUnit(DateTickUnitType.DATE_UNIT_MONTH)) ;
    xAxis.setTickValueFormatter(new MillisecondsToDateFormatter("yyyy-MM-dd")) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) xyplot.getRender() ;
    render.setBaseItemShapeVisible(false) ;
    render.setAutoSelectBorderPaint(false) ;
    render.setBaseItemBorderPaint(Color.blue) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    return chartpanel ;
  }

  private static ChartPanel createPanel4(String title, String rowKey, int inivVal, int cnt) {
    IMatrixDataset dataset = createDataset(rowKey, inivVal, cnt) ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart(title, "Date", "Price", dataset,
                                                           ChartOrientation.VERTICAL,
                                                           true, true, true, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    XYNumberValueAxis xAxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    xAxis.setTickUnit(new DateTickUnit(DateTickUnitType.DATE_UNIT_MONTH)) ;
    xAxis.setTickValueFormatter(new MillisecondsToDateFormatter("yyyy-MM-dd")) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) xyplot.getRender() ;
    render.setBaseItemShapeVisible(false) ;
    render.setAutoSelectBorderPaint(false) ;
    render.setBaseItemBorderPaint(Color.blue) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    return chartpanel ;
  }

  private static IMatrixDataset createDataset(String rowKey, double initVal, int cnt) {
    Calendar cal = Calendar.getInstance() ;

    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey(rowKey) ;
    dataset.addRowData() ;

    double val = initVal ;
    for (int i = 0 ; i < cnt ; i++) {
      int year = cal.get(Calendar.YEAR) ;
      int month = cal.get(Calendar.MONTH) + 1 ;
      int day = cal.get(Calendar.DAY_OF_MONTH) ;

      dataset.addData(0, createData(day, month, year, val)) ;
      val *= 1.0D + (Math.random() - 0.495D) / 10D ;
      cal.add(Calendar.DAY_OF_MONTH, 1) ;
    }

    return dataset ;
  }

  private static XYNumberChartData createData(int day, int month, int year, double value) {
    return new XYNumberChartData(DateUtil.dateToTimeInMillis(year, month, day), value) ;
  }

}
