package demo.xycharts ;

import java.awt.BasicStroke ;
import java.awt.BorderLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.tickunit.LogTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class LogAxisDemo1 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public LogAxisDemo1() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    DefaultMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createScatterChart("Marker Demo 1", "Time", "Y", dataset,
                                                    orientation, true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYNumberValueAxis xAxis = (XYNumberValueAxis) plot.getDomainAxis() ;
    xAxis.setTickUnit(new LogTickUnit()) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) plot.getValueAxis() ;
    yAxis.setTickUnit(new LogTickUnit(true, 0.2)) ;
    yAxis.setAxisRangeIncludeZero(false) ;

    plot.setDomainGridlineStroke(new BasicStroke(1.0F)) ;
    plot.setValueGridlineStroke(new BasicStroke(1.0F)) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static DefaultMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Supplier 1") ;
    dataset.addRowData() ;

    dataset.addData(0, new XYNumberChartData(1.0D, 500.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(5D, 694.10000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(4D, 100D)) ;
    dataset.addData(0, new XYNumberChartData(12.5D, 734.39999999999998D)) ;
    dataset.addData(0, new XYNumberChartData(17.300000000000001D, 453.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(21.199999999999999D, 500.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(21.899999999999999D, 9005.5D)) ;
    dataset.addData(0, new XYNumberChartData(25.600000000000001D, 734.39999999999998D)) ;
    dataset.addData(0, new XYNumberChartData(6663000D, 6453.1999999999998D)) ;

    return dataset ;
  }

}
