package demo.xycharts;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYDotRender ;
import demo.dataset.SampleXYDataset2 ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ScatterPlotDemo4 extends JPanel {

  public ScatterPlotDemo4() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    SampleXYDataset2 sample = new SampleXYDataset2(4, 40) ;
    IMatrixDataset dataset = sample.getDataset() ;
    IJChart chart = ChartFactory.createXYDotChart("Scatter Plot Demo 3", "X", "Y",
                                                  dataset, ChartOrientation.VERTICAL, true, true,
                                                  false, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.setDomainCrosshairVisible(true) ;
    plot.setDomainCrosshairLockedOnData(true) ;
    plot.setValueCrosshairVisible(true) ;
    plot.setValueCrosshairLockedOnData(true) ;
    plot.setDomainZeroBaselineVisible(true) ;
    plot.setValueZeroBaselineVisible(true) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) plot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;
    yAxis.setGridBandVisible(true) ;
    yAxis.setGridBandPaint(new Color(200, 200, 100, 100)) ;

    XYDotRender render = (XYDotRender) plot.getRender() ;
    render.setDotWidth(4) ;
    render.setDotHeight(4) ;

    plot.setDomainCrosshairVisible(true) ;
    plot.setValueCrosshairVisible(true) ;
    XYNumberValueAxis xAxis = (XYNumberValueAxis) plot.getDomainAxis() ;
    xAxis.setAxisRangeIncludeZero(false) ;
    xAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

}
