package demo.xycharts;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYSeriesDemo2 extends JPanel {

  public XYSeriesDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IJChart chart = ChartFactory.createXYLineAndShapeChart(
      "XY Series Demo 2", "X", "Y", createDataset(), ChartOrientation.VERTICAL,
      true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    NumberValueAxis numberaxis = (NumberValueAxis) plot.getValueAxis() ;
    numberaxis.setUserDefineDatasetRange(99.5, 100.5) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    render.setRowItemShapeVisible(0, false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    dataset.addRowData() ;
    dataset.addRowKey("Flat Data") ;

    dataset.addData(0, new XYNumberChartData(1.0D, 100D)) ;
    dataset.addData(0, new XYNumberChartData(5D, 100D)) ;
    dataset.addData(0, new XYNumberChartData(4D, 100D)) ;
    dataset.addData(0, new XYNumberChartData(12.5D, 100D)) ;
    dataset.addData(0, new XYNumberChartData(17.300000000000001D, 100D)) ;
    dataset.addData(0, new XYNumberChartData(21.199999999999999D, 100D)) ;
    dataset.addData(0, new XYNumberChartData(21.899999999999999D, 100D)) ;
    dataset.addData(0, new XYNumberChartData(25.600000000000001D, 100D)) ;
    dataset.addData(0, new XYNumberChartData(30D, 100D)) ;

    return dataset ;
  }

}
