package com.ijchart.xychart.constant ;

import java.io.Serializable ;

import com.ijchart.xychart.util.HashcodeUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ͼϢеͼε.</zh>
 * <en>Describe the type of {@link com.ijchart.xychart.shape.IChartShape} drawing on the chart.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class ChartShapeDrawType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 4870776367231884566L ;

  /**
   * <zh>͵ͼ.</zh>
   * <en>Any type shape.</en>
   */
  public static final ChartShapeDrawType ANY_SHAPE = new ChartShapeDrawType("ANY") ;

  /**
   * <zh>ע(Annotation)ͼ.</zh>
   * <en>Annotation shape.</en>
   */
  public static final ChartShapeDrawType ANNOTATION_SHAPE = new ChartShapeDrawType("ANNOTATION") ;

  /**
   * <zh>ǩͼμ.</zh>
   * <en>The axis label shape.</en>
   */
  public static final ChartShapeDrawType AXIS_LABEL_SHAPE = new ChartShapeDrawType("AXIS_LABEL") ;

  /**
   * <zh>ͼμ.</zh>
   * <en>The axis line shape.</en>
   */
  public static final ChartShapeDrawType AXIS_LINE_SHAPE = new ChartShapeDrawType("AXIS_LINE") ;

  /**
   * <zh>3D͵.</zh>
   * <en>The axis line 3D area.</en>
   */
  public static final ChartShapeDrawType AXIS_LINE_3D_SHAPE =
    new ChartShapeDrawType("AXIS_LINE_3D") ;

  /**
   * <zh>̶ȱǩͼ.</zh>
   * <en>The axis tick label shape.</en>
   */
  public static final ChartShapeDrawType AXIS_TICK_LABEL_SHAPE =
    new ChartShapeDrawType("AXIS_TICK_LABEL") ;

  /**
   * <zh>̶ͼ.</zh>
   * <en>The axis tick mark shape.</en>
   */
  public static final ChartShapeDrawType AXIS_TICK_MARK_SHAPE =
    new ChartShapeDrawType("AXIS_TICK_MARK") ;

  /**
   * <zh>CHARTı߿ͼ.</zh>
   * <en>The chart border shape.</en>
   */
  public static final ChartShapeDrawType CHART_BORDER_SHAPE =
    new ChartShapeDrawType("CHART_BORDER") ;

  /**
   * <zh>chartıͼ.</zh>
   * <en>The chart background shape.</en>
   */
  public static final ChartShapeDrawType CHART_BACKGROUND_SHAPE =
    new ChartShapeDrawType("CHART_BACKGROUND") ;

  /**
   * <zh>chartıͼƬͼ.</zh>
   * <en>The chart background image shape.</en>
   */
  public static final ChartShapeDrawType CHART_BACKGROUND_IMAGE_SHAPE =
    new ChartShapeDrawType("CHART_BACKGROUND_IMAGE") ;

  /**
   * <zh>ͼ߿ͼ.</zh>
   * <en>The legend border shape.</en>
   */
  public static final ChartShapeDrawType LEGEND_BORDER_SHAPE =
    new ChartShapeDrawType("LEGEND_BORDER") ;

  /**
   * <zh>ͼͼ.</zh>
   * <en>The legend shape.</en>
   */
  public static final ChartShapeDrawType LEGEND_SHAPE = new ChartShapeDrawType("LEGEND") ;

  /**
   * <zh>plot߿ͼ.</zh>
   * <en>The plot border shape.</en>
   */
  public static final ChartShapeDrawType PLOT_BORDER_SHAPE = new ChartShapeDrawType("PLOT_BORDER") ;

  /**
   * <zh>plotıͼ.</zh>
   * <en>The plot background shape.</en>
   */
  public static final ChartShapeDrawType PLOT_BACKGROUND_SHAPE =
    new ChartShapeDrawType("PLOT_BACKGROUND") ;

  /**
   * <zh>plotıͼƬͼ.</zh>
   * <en>The plot background image shape.</en>
   */
  public static final ChartShapeDrawType PLOT_BACKGROUND_IMAGE_SHAPE =
    new ChartShapeDrawType("PLOT_BACKGROUND_IMAGE") ;

  /**
   * <zh>plotûʱϢͼ.</zh>
   * <en>The no data message shape for plot.</en>
   */
  public static final ChartShapeDrawType PLOT_NO_DATA_MESSAGE_SHAPE =
    new ChartShapeDrawType("PLOT_NO_DATA_MESSAGE") ;

  /**
   * <zh>xʮ.</zh>
   * <en>The x-cross shape.</en>
   */
  public static final ChartShapeDrawType PLOT_X_CROSS_SHAPE =
    new ChartShapeDrawType("PLOT_X_CROSS") ;

  /**
   * <zh>yʮ.</zh>
   * <en>The y-cross shape.</en>
   */
  public static final ChartShapeDrawType PLOT_Y_CROSS_SHAPE =
    new ChartShapeDrawType("PLOT_Y_CROSS") ;

  /**
   * <zh>domain0ֵ.</zh>
   * <en>The zero line of domain axis.</en>
   */
  public static final ChartShapeDrawType PLOT_ZERO_DOMAIN_BASE_LINE_SHAPE =
    new ChartShapeDrawType("PLOT_ZERO_DOMAIN_BASE_LINE") ;

  /**
   * <zh>value0ֵ.</zh>
   * <en>The zero line of value axis.</en>
   */
  public static final ChartShapeDrawType PLOT_ZERO_VALUE_BASE_LINE_SHAPE =
    new ChartShapeDrawType("PLOT_ZERO_VALUE_BASE_LINE") ;

  /**
   * <zh>render߿ͼ.</zh>
   * <en>The render border shape.</en>
   */
  public static final ChartShapeDrawType RENDER_BORDER_SHAPE =
    new ChartShapeDrawType("RENDER_BORDER") ;

  /**
   * <zh>renderıͼ.</zh>
   * <en>The render background shape.</en>
   */
  public static final ChartShapeDrawType RENDER_BACKGROUND_SHAPE =
    new ChartShapeDrawType("RENDER_BACKGROUND") ;

  /**
   * <zh>renderޱͼ.</zh>
   * <en>The render quadrant background shape.</en>
   */
  public static final ChartShapeDrawType RENDER_QUADRANT_BACKGROUND_SHAPE =
    new ChartShapeDrawType("RENDER_QUADRANT_BACKGROUND") ;

  /**
   * <zh>renderıͼƬͼ.</zh>
   * <en>The render background image shape.</en>
   */
  public static final ChartShapeDrawType RENDER_BACKGROUND_IMAGE_SHAPE =
    new ChartShapeDrawType("RENDER_BACKGROUND_IMAGE") ;

  /**
   * <zh>domainͼ.</zh>
   * <en>The domain grid line shape.</en>
   */
  public static final ChartShapeDrawType RENDER_DOMAIN_GRIDLINE_SHAPE =
    new ChartShapeDrawType("RENDER_DOMAIN_GRIDLINE") ;

  /**
   * <zh>valueͼ.</zh>
   * <en>The value grid line shape.</en>
   */
  public static final ChartShapeDrawType RENDER_VALUE_GRIDLINE_SHAPE =
    new ChartShapeDrawType("RENDER_VALUE_GRIDLINE") ;

  /**
   * <zh>valueͼ.</zh>
   * <en>The value grid band shape.</en>
   */
  public static final ChartShapeDrawType RENDER_VALUE_GRIDBAND_SHAPE =
    new ChartShapeDrawType("RENDER_VALUE_GRIDBAND") ;

  /**
   * <zh>ֵ(value line)ͼ.</zh>
   * <en>The value line shape.</en>
   */
  public static final ChartShapeDrawType RENDER_VALUE_LINE_SHAPE =
    new ChartShapeDrawType("RENDER_VALUE_LINE") ;

  /**
   * <zh>markerͼ.</zh>
   * <en>The background marker shape.</en>
   */
  public static final ChartShapeDrawType RENDER_BACKGROUND_MARKER_SHAPE =
    new ChartShapeDrawType("RENDER_BACKGROUND_MARKER") ;

  /**
   * <zh>3Dͼ.</zh>
   * <en>The shape for close render area of 3D chart.</en>
   */
  public static final ChartShapeDrawType RENDER_3D_CLOSE_LINE_SHAPE =
    new ChartShapeDrawType("RENDER_3D_CLOSE_LINE") ;

  /**
   * <zh>ǰmarkerͼ.</zh>
   * <en>The foreground marker shape.</en>
   */
  public static final ChartShapeDrawType RENDER_FOREGROUND_MARKER_SHAPE =
    new ChartShapeDrawType("RENDER_FOREGROUND_MARKER") ;

  /**
   * <zh>interval markerͼ.</zh>
   * <en>The background interval marker shape.</en>
   */
  public static final ChartShapeDrawType RENDER_BACKGROUND_INTERVAL_MARKER_SHAPE =
    new ChartShapeDrawType("RENDER_BACKGROUND_INTERVAL_MARKER") ;

  /**
   * <zh>ǰinterval markerͼ.</zh>
   * <en>The foreground interval marker shape.</en>
   */
  public static final ChartShapeDrawType RENDER_FOREGROUND_INTERVAL_MARKER_SHAPE =
    new ChartShapeDrawType("RENDER_FOREGROUND_INTERVAL_MARKER") ;

  /**
   * <zh>̶ȱǩͼ.</zh>
   * <en>The tick label shape.</en>
   */
  public static final ChartShapeDrawType RENDER_TICK_LABEL_SHAPE =
    new ChartShapeDrawType("RENDER_TICK_LABEL") ;

  /**
   * <zh>̶(tick line)ͼ.</zh>
   * <en>The tick line shape.</en>
   */
  public static final ChartShapeDrawType RENDER_TICK_LINE_SHAPE =
    new ChartShapeDrawType("RENDER_TICK_LINE") ;

  /**
   * <zh>ƫͼ.</zh>
   * <en>The deviation shape.</en>
   */
  public static final ChartShapeDrawType RENDER_DEVIATION_SHAPE =
    new ChartShapeDrawType("RENDER_DEVIATION") ;

  /**
   * <zh>(difference)ͼεıɫ.</zh>
   * <en>The background of difference shape.</en>
   */
  public static final ChartShapeDrawType RENDER_DIFFERENCE_BACKGROUND_SHAPE =
    new ChartShapeDrawType("RENDER_DIFFERENCE_BACKGROUND") ;

  /**
   * <zh>ÿݵӦͼεıͼ.</zh>
   * <en>The data item background shape.</en>
   */
  public static final ChartShapeDrawType RENDER_DATA_ITEM_BACKGROUND_SHAPE =
    new ChartShapeDrawType("RENDER_DATA_ITEM_BACKGROUND") ;

  /**
   * <zh>Сֵֵͼ.</zh>
   * <en>The min-max value shape.</en>
   */
  public static final ChartShapeDrawType RENDER_MIN_MAX_VALUE_SHAPE =
    new ChartShapeDrawType("RENDER_MIN_MAX_VALUE_SHAPE") ;

  /**
   * <zh>ֵͼ.</zh>
   * <en>The value-line shape.</en>
   */
  public static final ChartShapeDrawType RENDER_MIN_MAX_VALUE_LINE_SHAPE =
    new ChartShapeDrawType("RENDER_MIN_MAX_VALUE_LINE_SHAPE") ;

  /**
   * <zh>ͼ.</zh>
   * <en>The join line shape.</en>
   */
  public static final ChartShapeDrawType RENDER_JOIN_LINE_SHAPE =
    new ChartShapeDrawType("RENDER_JOIN_LINE_SHAPE") ;

  /**
   * <zh>ͼ.</zh>
   * <en>The guid line shape.</en>
   */
  public static final ChartShapeDrawType RENDER_GUIDE_LINE_SHAPE =
    new ChartShapeDrawType("RENDER_GUIDE_LINE_SHAPE") ;

  /**
   * <zh>ÿݵӦͼ.</zh>
   * <en>The data item shape.</en>
   */
  public static final ChartShapeDrawType RENDER_DATA_ITEM_SHAPE =
    new ChartShapeDrawType("RENDER_DATA_ITEM") ;

  /**
   * <zh>Ǳָͼ.</zh>
   * <en>The needle shape of meter chart.</en>
   */
  public static final ChartShapeDrawType RENDER_METER_NEEDLE_SHAPE =
    new ChartShapeDrawType("RENDER_METER_NEEDLE") ;

  /**
   * <zh>Ǳ̵λͼ.</zh>
   * <en>The unit shape of meter chart.</en>
   */
  public static final ChartShapeDrawType RENDER_METER_UNIT_SHAPE =
    new ChartShapeDrawType("RENDER_METER_UNIT") ;

  /**
   * <zh>ǱͼεĿ̶ֵǩ.</zh>
   * <en>The meter arc tick label.</en>
   */
  public static final ChartShapeDrawType RENDER_METER_ARC_TICK_LABEL_SHAPE =
    new ChartShapeDrawType("RENDER_METER_ARC_TICK_LABEL") ;

  /**
   * <zh>ǱͼεĿ̶.</zh>
   * <en>The meter arc tick line.</en>
   */
  public static final ChartShapeDrawType RENDER_METER_ARC_TICK_LINE_SHAPE =
    new ChartShapeDrawType("RENDER_METER_ARC_TICK_LINE") ;

  /**
   * <zh>Ӱͼ.</zh>
   * <en>The shadow shape.</en>
   */
  public static final ChartShapeDrawType RENDER_SHADOW_SHAPE =
    new ChartShapeDrawType("RENDER_SHADOW") ;

  /**
   * <zh>ͼǩͼ.</zh>
   * <en>The pie label shape.</en>
   */
  public static final ChartShapeDrawType RENDER_PIE_LABEL_SHAPE =
    new ChartShapeDrawType("RENDER_PIE_LABEL") ;

  /**
   * <zh>3DЧıͼ.</zh>
   * <en>The pie 3D effect shape.</en>
   */
  public static final ChartShapeDrawType RENDER_PIE_3D_EFFECT_SHAPE =
    new ChartShapeDrawType("RENDER_PIE_3D_EFFECT") ;

  /**
   * <zh>ͼİ뾶.</zh>
   * <en>The radius gridline shape.</en>
   */
  public static final ChartShapeDrawType RENDER_RADIUS_GRIDLINE_SHAPE =
    new ChartShapeDrawType("RENDER_RADIUS_GRIDLINE") ;

  /**
   * <zh>ͼĽǶȱ.</zh>
   * <en>The angle gridline shape.</en>
   */
  public static final ChartShapeDrawType RENDER_ANGLE_GRIDLINE_SHAPE =
    new ChartShapeDrawType("RENDER_ANGLE_GRIDLINE") ;

  /**
   * <zh>һͼ.</zh>
   * <en>The title shape.</en>
   */
  public static final ChartShapeDrawType TITLE_SHAPE =
    new ChartShapeDrawType("TITLE") ;

  /**
   * <zh>.</zh>
   * <en>The type.</en>
   */
  private String type ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param type String <zh>.</zh>
   * <en>The type.</en>
   */
  private ChartShapeDrawType(String type) {
    this.type = type ;
  }

  /**
   * <zh>equals.</zh>
   * <en>Override equals method.</en>
   * @param obj Object
   * @return boolean
   */
  public boolean equals(Object obj) {
    if (this == obj) {
      return true ;
    }

    if (!(obj instanceof ChartShapeDrawType)) {
      return false ;
    }

    ChartShapeDrawType that = (ChartShapeDrawType) obj ;

    return this.type.equals(that.type) ;
  }

  /**
   * <zh>toString().</zh>
   * <en>Override toString method.</en>
   * @return String
   */
  public String toString() {
    return this.type ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object. </en>
   * @return  a hash code value for this object.
   */
  public int hashCode() {
    return HashcodeUtil.hashCode(this.type) ;
  }

}
