package com.ijchart.xychart.dataset ;

import java.util.List ;

import com.ijchart.xychart.data.IChartData ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ӿڼ̳{@link IDataset},ݼеÿһֵֵ,ֵҪʵObject.equals()
 * ,ֵ{@link com.ijchart.xychart.data.IChartData}ľʵ.</zh>
 * <en>An extension of the {@link com.ijchart.xychart.data.IChartData} interface where a unique key
 * is associated with a value.The key class must override the equals method inherit from Object
 * class,the value class must implement {@link com.ijchart.xychart.data.IChartData} interface.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public interface IKeyValueDataset extends IDataset {

  /**
   * <zh>мֵ</zh>
   * <en>Returns all the keys.</en>
   *
   * @return <zh>мֵ</zh>
   * <en>All the keys list.</en>
   */
  List getAllKeys() ;

  /**
   * <zh>ݼֵӦֵ.</zh>
   * <en>Returns the data associate with this key.</en>
   * @param key Object
   * @return IChartData
   */
  IChartData getDataByKey(Object key) ;

  /**
   * <zh>ؼֵмֵе.</zh>
   * <en>Returns the index for a given key.</en>
   *
   * @param key Object <zh>ֵ</zh>
   * <en>The key object.</en>
   * @return int <zh>ֵмֵе,ûҵ򷵻-1.</zh>
   * <en>The column index, or -1 if the key is unrecognised.</en>
   */
  int getKeyIndex(Object key) ;

  /**
   * <zh>ݼֵĸ.</zh>
   * <en>Returns the size of this dataset.</en>
   * @return int
   */
  int getDataSize() ;
}
