package com.ijchart.xychart.dataset ;

import com.ijchart.xychart.constant.SortType ;
import com.ijchart.xychart.data.IChartData ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ݼʾά͵ݼ,RowKey,ColKeyݵ,еÿݵ㶼{@link IChartData}
 * .ÿһжӦһRowKey,ÿһжӦһColKey.ʽ:
 * <br>
 * <table width="400" border="1" cellspacing="1">
 *   <tr>
 *     <td width="70" align="center">&nbsp;</td>
 *     <td width="110" align="center">ColKey<sub>1</sub></td>
 *     <td width="110" align="center">ColKey<sub>2</sub></td>
 *     <td width="110" align="center">ColKey<sub>3</sub></td>
 *   </tr>
 *   <tr>
 *     <td align="center">RowKey<sub>1</sub></td>
 *     <td align="center">ChartData<sub>11</sub></td>
 *     <td align="center">ChartData<sub>12</sub></td>
 *     <td align="center">ChartData<sub>13</sub></td>
 *   </tr>
 *   <tr>
 *     <td align="center">RowKey<sub>2</sub></td>
 *     <td align="center">ChartData<sub>21</sub></td>
 *     <td align="center">ChartData<sub>22</sub></td>
 *     <td align="center">ChartData<sub>23</sub></td>
 *   </tr>
 *   <tr>
 *     <td align="center">RowKey<sub>3</sub></td>
 *     <td align="center">ChartData<sub>31</sub></td>
 *     <td align="center">ChartData<sub>32</sub></td>
 *     <td align="center">ChartData<sub>33</sub></td>
 *   </tr>
 * </table>
 * <br>еRowKeyʾΪXıǩ,ColKeyʾΪͼ.
 * </zh>
 * <en>The dataset is a two-dimensional matrix, each point in the matrix is
 * (@Link IChartData) object. Matrix of each row of a corresponding RowKey,each column of a
 *  corresponding ColKey.The data form is:
 * <br>
 * <table width="400" border="1" cellspacing="1">
 *   <tr>
 *     <td width="70" align="center">&nbsp;</td>
 *     <td width="110" align="center">ColKey<sub>1</sub></td>
 *     <td width="110" align="center">ColKey<sub>2</sub></td>
 *     <td width="110" align="center">ColKey<sub>3</sub></td>
 *   </tr>
 *   <tr>
 *     <td align="center">RowKey<sub>1</sub></td>
 *     <td align="center">ChartData<sub>11</sub></td>
 *     <td align="center">ChartData<sub>12</sub></td>
 *     <td align="center">ChartData<sub>13</sub></td>
 *   </tr>
 *   <tr>
 *     <td align="center">RowKey<sub>2</sub></td>
 *     <td align="center">ChartData<sub>21</sub></td>
 *     <td align="center">ChartData<sub>22</sub></td>
 *     <td align="center">ChartData<sub>23</sub></td>
 *   </tr>
 *   <tr>
 *     <td align="center">RowKey<sub>3</sub></td>
 *     <td align="center">ChartData<sub>31</sub></td>
 *     <td align="center">ChartData<sub>32</sub></td>
 *     <td align="center">ChartData<sub>33</sub></td>
 *   </tr>
 * </table>
 * <br>The RowKey is used to draw on X-axis,and ColKey is used to draw as legend.
 * </en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */

public interface IMatrixDataset extends IDataset {
  /**
   * <zh>ݼ.</zh>
   * <en>The row count of this dataset.</en>
   *
   * @return int <zh>ݼ.</zh>
   * <en>The row count.</en>
   */
  int getRowCount() ;

  /**
   * <zh>indexõеRowKeyֵ,һΪ0,ڶΪ1,.</zh>
   * <en>Get RowKey by index.The first RowKey of the dataset is at index 0,the next at index 1,
   *  and so on, as for array indexing.</en>
   *
   * @param index int <zh>,һΪ0,ڶΪ1.</zh>
   * <en>The row index,first is 0,next is 1.</en>
   * @return Object <zh>еRowKey,û򷵻null.</zh>
   * <en>The dataset RowKey for this index,if not found return null.</en>
   */
  Object getRowKey(int index) ;

  /**
   * <zh>ݼ.</zh>
   * <en>The column count of this dataset.</en>
   *
   * @return int <zh>ݼ.</zh>
   * <en>The column count.</en>
   */
  int getColumnCount() ;

  /**
   * <zh>ݼ.</zh>
   * <en>The column count of this dataset.</en>
   *
   * @param rowIdx int <zh>.</zh>
   * <en>The row index.</en>
   * @return int <zh>ݼ.</zh>
   * <en>The column count.</en>
   */
  int getColumnCount(int rowIdx) ;

  /**
   * <zh>indexõеColKeyֵ,һΪ0,ڶΪ1,.</zh>
   * <en>Get ColKey by index.The first ColKey of the dataset is at index 0,the next at index 1,
   *  and so on, as for array indexing.</en>
   *
   * @param index int <zh>,һΪ0,ڶΪ1.</zh>
   * <en>The index,first is 0,next is 1.</en>
   * @return Object <zh>еColKey,û򷵻null.</zh>
   * <en>The dataset ColKey for this index,if not found return null.</en>
   */
  Object getColKey(int index) ;

  /**
   * <zh>õάеĳֵ,rowIndexcolIndexΧ׳쳣.</zh>
   * <en>Get the data of matrix by rowIndex and colIndex,an Exception will be throw when index out
   * of bound.</en>
   *
   * @param rowIndex int <zh>ֵ,һ0,ڶ1,.</zh>
   * <en>The row index.The first is at index 0,the next is at 1, and so on.</en>
   * @param colIndex int <zh>ֵ,һ0,ڶ1,.</zh>
   * <en>The column index.The first is at index 0,the next is at 1, and so on.</en>
   * @return IChartData <zh>иõֵ(Ϊnull).</zh>
   * <en>The data of matrix (maybe null).</en>
   */
  IChartData getData(int rowIndex, int colIndex) ;

  /**
   * <zh>ݼǷΪ.</zh>
   * <en>Returns whether or not the dataset is empty.</en>
   *
   * @return boolean <zh>յݼtrue,Ϊfalse.</zh>
   * <en>Returns true if the axis dataset is empty,otherwise false.</en>
   */
  boolean isEmpty() ;

  /**
   * <zh>ݼеһݽ.</zh>
   * <en>Sort the datas of a dataset row.</en>
   *
   * @param rowIndex int <zh>ֵ,һ0,ڶ1,.</zh>
   * <en>The row index.The first is at index 0,the next is at 1, and so on.</en>
   * @param sortType SortType <zh> (Ϊnull).</zh>
   * <en>The sort type,ascending or descending.</en>
   */
  void sortRowData(int rowIndex, SortType sortType) ;
}
