package com.ijchart.xychart.event ;

import java.io.Serializable ;
import java.util.EventObject ;

import com.ijchart.xychart.render.IRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>render仯¼.</zh>
 * <en>A change event that encapsulates information about a change to a render.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class RenderChangeEvent extends EventObject implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 185017193765399466L ;

  /**
   * <zh>¼render.</zh>
   * <en>The render that generated the event.</en>
   */
  private IRender render ;

  /**
   * <zh>.</zh>
   * <en>Creates a new event.</en>
   *
   * @param render IRender <zh>¼render.</zh>
   * <en>The render that generated the event.</en>
   */
  public RenderChangeEvent(IRender render) {
    super(render) ;
    this.render = render ;
  }

  /**
   * <zh>ز¼render.</zh>
   * <en>Returns the render that generated the event.</en>
   *
   * @return <zh>ز¼render.</zh>
   * <en>The render that generated the event.</en>
   */
  public IRender getRender() {
    return this.render ;
  }
}
