package com.ijchart.xychart.function ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ֱߺ,ʽΪy=a+bx.</zh>
 * <en>A function in the form y = a + bx.</en>
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class LineFunction implements IFunction, Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 2884191234003018467L ;

  /**
   * <zh>ؾ.</zh>
   * <en>The intercept.</en>
   */
  private double a ;

  /**
   * <zh>б.</zh>
   * <en>The slope of the line.</en>
   */
  private double b ;

  /**
   * <zh>ݽؾбʹֱ.</zh>
   * <en>Constructs a new line function.</en>
   *
   * @param a double <zh>ؾ.</zh>
   * <en>The intercept.</en>
   * @param b double <zh>б.</zh>
   * <en>The slope of the line.</en>
   */
  public LineFunction(double a, double b) {
    this.a = a ;
    this.b = b ;
  }

  /**
   * <zh>ؽؾ.</zh>
   * <en>Returns the intercept.</en>
   *
   * @return double <zh>ؾ.</zh>
   * <en>The intercept.</en>
   */
  public double getA() {
    return this.a ;
  }

  /**
   * <zh>б.</zh>
   * <en>Returns the slope of the line.</en>
   *
   * @return double <zh>б.</zh>
   * <en>The slope of the line.</en>
   */
  public double getB() {
    return this.b ;
  }

  /**
   * <zh>xֵyֵ.</zh>
   * <en>Calculate the y value for a given inpu x.</en>
   *
   * @param x double <zh>xֵ.</zh>
   * <en>The x value.</en>
   * @return double <zh>yֵ.</zh>
   * <en>The y value.</en>
   */
  public double getY(double x) {
    return this.a + this.b * x ;
  }

  /**
   * <zh>equals.</zh>
   * <en>Override equals method.</en>
   * @param obj Object
   * @return boolean
   */
  public boolean equals(Object obj) {
    if (this == obj) {
      return true ;
    }

    if (!(obj instanceof LineFunction)) {
      return false ;
    }

    LineFunction that = (LineFunction) obj ;

    return this.a == that.a && this.b == that.b ;
  }

  /**
   * <zh>toString().</zh>
   * <en>Override toString method.</en>
   * @return String
   */
  public String toString() {
    return "[a=" + this.a + ",b=" + this.b + "]" ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object. </en>
   * @return  a hash code value for this object.
   */
  public int hashCode() {
    return (int) ((this.a + this.b) * 1000) ;
  }

}
